import modal.client
import modal.object
import synchronicity.combined_types
import typing
import typing_extensions

def _serialize_dict(data): ...

class _Dict(modal.object._Object):
    @staticmethod
    def new(data: typing.Optional[dict] = None): ...
    def __init__(self, data={}): ...
    @classmethod
    def ephemeral(
        cls: typing.Type[_Dict],
        data: typing.Optional[dict] = None,
        client: typing.Optional[modal.client._Client] = None,
        environment_name: typing.Optional[str] = None,
        _heartbeat_sleep: float = 300,
    ) -> typing.AsyncContextManager[_Dict]: ...
    @staticmethod
    def from_name(
        label: str,
        data: typing.Optional[dict] = None,
        namespace=1,
        environment_name: typing.Optional[str] = None,
        create_if_missing: bool = False,
    ) -> _Dict: ...
    @staticmethod
    def persisted(label: str, namespace=1, environment_name: typing.Optional[str] = None): ...
    @staticmethod
    async def lookup(
        label: str,
        data: typing.Optional[dict] = None,
        namespace=1,
        client: typing.Optional[modal.client._Client] = None,
        environment_name: typing.Optional[str] = None,
        create_if_missing: bool = False,
    ) -> _Dict: ...
    @staticmethod
    async def delete(
        label: str,
        *,
        client: typing.Optional[modal.client._Client] = None,
        environment_name: typing.Optional[str] = None,
    ): ...
    async def clear(self) -> None: ...
    async def get(self, key: typing.Any, default: typing.Optional[typing.Any] = None) -> typing.Any: ...
    async def contains(self, key: typing.Any) -> bool: ...
    async def len(self) -> int: ...
    async def __getitem__(self, key: typing.Any) -> typing.Any: ...
    async def update(self, **kwargs) -> None: ...
    async def put(self, key: typing.Any, value: typing.Any) -> None: ...
    async def __setitem__(self, key: typing.Any, value: typing.Any) -> None: ...
    async def pop(self, key: typing.Any) -> typing.Any: ...
    async def __delitem__(self, key: typing.Any) -> typing.Any: ...
    async def __contains__(self, key: typing.Any) -> bool: ...
    def keys(self) -> typing.AsyncIterator[typing.Any]: ...
    def values(self) -> typing.AsyncIterator[typing.Any]: ...
    def items(self) -> typing.AsyncIterator[typing.Tuple[typing.Any, typing.Any]]: ...

class Dict(modal.object.Object):
    def __init__(self, data={}): ...
    @staticmethod
    def new(data: typing.Optional[dict] = None): ...
    @classmethod
    def ephemeral(
        cls: typing.Type[Dict],
        data: typing.Optional[dict] = None,
        client: typing.Optional[modal.client.Client] = None,
        environment_name: typing.Optional[str] = None,
        _heartbeat_sleep: float = 300,
    ) -> synchronicity.combined_types.AsyncAndBlockingContextManager[Dict]: ...
    @staticmethod
    def from_name(
        label: str,
        data: typing.Optional[dict] = None,
        namespace=1,
        environment_name: typing.Optional[str] = None,
        create_if_missing: bool = False,
    ) -> Dict: ...
    @staticmethod
    def persisted(label: str, namespace=1, environment_name: typing.Optional[str] = None): ...

    class __lookup_spec(typing_extensions.Protocol):
        def __call__(
            self,
            label: str,
            data: typing.Optional[dict] = None,
            namespace=1,
            client: typing.Optional[modal.client.Client] = None,
            environment_name: typing.Optional[str] = None,
            create_if_missing: bool = False,
        ) -> Dict: ...
        async def aio(self, *args, **kwargs) -> Dict: ...

    lookup: __lookup_spec

    class __delete_spec(typing_extensions.Protocol):
        def __call__(
            self,
            label: str,
            *,
            client: typing.Optional[modal.client.Client] = None,
            environment_name: typing.Optional[str] = None,
        ): ...
        async def aio(self, *args, **kwargs): ...

    delete: __delete_spec

    class __clear_spec(typing_extensions.Protocol):
        def __call__(self) -> None: ...
        async def aio(self, *args, **kwargs) -> None: ...

    clear: __clear_spec

    class __get_spec(typing_extensions.Protocol):
        def __call__(self, key: typing.Any, default: typing.Optional[typing.Any] = None) -> typing.Any: ...
        async def aio(self, *args, **kwargs) -> typing.Any: ...

    get: __get_spec

    class __contains_spec(typing_extensions.Protocol):
        def __call__(self, key: typing.Any) -> bool: ...
        async def aio(self, *args, **kwargs) -> bool: ...

    contains: __contains_spec

    class __len_spec(typing_extensions.Protocol):
        def __call__(self) -> int: ...
        async def aio(self, *args, **kwargs) -> int: ...

    len: __len_spec

    class ____getitem___spec(typing_extensions.Protocol):
        def __call__(self, key: typing.Any) -> typing.Any: ...
        async def aio(self, *args, **kwargs) -> typing.Any: ...

    __getitem__: ____getitem___spec

    class __update_spec(typing_extensions.Protocol):
        def __call__(self, **kwargs) -> None: ...
        async def aio(self, *args, **kwargs) -> None: ...

    update: __update_spec

    class __put_spec(typing_extensions.Protocol):
        def __call__(self, key: typing.Any, value: typing.Any) -> None: ...
        async def aio(self, *args, **kwargs) -> None: ...

    put: __put_spec

    class ____setitem___spec(typing_extensions.Protocol):
        def __call__(self, key: typing.Any, value: typing.Any) -> None: ...
        async def aio(self, *args, **kwargs) -> None: ...

    __setitem__: ____setitem___spec

    class __pop_spec(typing_extensions.Protocol):
        def __call__(self, key: typing.Any) -> typing.Any: ...
        async def aio(self, *args, **kwargs) -> typing.Any: ...

    pop: __pop_spec

    class ____delitem___spec(typing_extensions.Protocol):
        def __call__(self, key: typing.Any) -> typing.Any: ...
        async def aio(self, *args, **kwargs) -> typing.Any: ...

    __delitem__: ____delitem___spec

    class ____contains___spec(typing_extensions.Protocol):
        def __call__(self, key: typing.Any) -> bool: ...
        async def aio(self, *args, **kwargs) -> bool: ...

    __contains__: ____contains___spec

    class __keys_spec(typing_extensions.Protocol):
        def __call__(self) -> typing.Iterator[typing.Any]: ...
        def aio(self) -> typing.AsyncIterator[typing.Any]: ...

    keys: __keys_spec

    class __values_spec(typing_extensions.Protocol):
        def __call__(self) -> typing.Iterator[typing.Any]: ...
        def aio(self) -> typing.AsyncIterator[typing.Any]: ...

    values: __values_spec

    class __items_spec(typing_extensions.Protocol):
        def __call__(self) -> typing.Iterator[typing.Tuple[typing.Any, typing.Any]]: ...
        def aio(self) -> typing.AsyncIterator[typing.Tuple[typing.Any, typing.Any]]: ...

    items: __items_spec
